# coding: utf-8

"""
    The Jira Cloud platform REST API

    Jira Cloud platform REST API documentation

    The version of the OpenAPI document: 1001.0.0-SNAPSHOT-7ce0ee67a52d004425175cea962ad1c1c7200181
    Contact: ecosystem@atlassian.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AnnouncementBannerConfiguration(BaseModel):
    """
    Announcement banner configuration.
    """ # noqa: E501
    hash_id: Optional[StrictStr] = Field(default=None, description="Hash of the banner data. The client detects updates by comparing hash IDs.", alias="hashId")
    is_dismissible: Optional[StrictBool] = Field(default=None, description="Flag indicating if the announcement banner can be dismissed by the user.", alias="isDismissible")
    is_enabled: Optional[StrictBool] = Field(default=None, description="Flag indicating if the announcement banner is enabled or not.", alias="isEnabled")
    message: Optional[StrictStr] = Field(default=None, description="The text on the announcement banner.")
    visibility: Optional[StrictStr] = Field(default=None, description="Visibility of the announcement banner.")
    __properties: ClassVar[List[str]] = ["hashId", "isDismissible", "isEnabled", "message", "visibility"]

    @field_validator('visibility')
    def visibility_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['PUBLIC', 'PRIVATE']):
            raise ValueError("must be one of enum values ('PUBLIC', 'PRIVATE')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AnnouncementBannerConfiguration from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "hash_id",
            "is_dismissible",
            "is_enabled",
            "message",
            "visibility",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AnnouncementBannerConfiguration from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "hashId": obj.get("hashId"),
            "isDismissible": obj.get("isDismissible"),
            "isEnabled": obj.get("isEnabled"),
            "message": obj.get("message"),
            "visibility": obj.get("visibility")
        })
        return _obj


