# coding: utf-8

"""
    The Jira Cloud platform REST API

    Jira Cloud platform REST API documentation

    The version of the OpenAPI document: 1001.0.0-SNAPSHOT-7ce0ee67a52d004425175cea962ad1c1c7200181
    Contact: ecosystem@atlassian.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List
from jira_client.models.available_workflow_trigger_types import AvailableWorkflowTriggerTypes
from typing import Optional, Set
from typing_extensions import Self

class AvailableWorkflowTriggers(BaseModel):
    """
    The trigger rules available.
    """ # noqa: E501
    available_types: List[AvailableWorkflowTriggerTypes] = Field(description="The list of available trigger types.", alias="availableTypes")
    rule_key: StrictStr = Field(description="The rule key of the rule.", alias="ruleKey")
    __properties: ClassVar[List[str]] = ["availableTypes", "ruleKey"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AvailableWorkflowTriggers from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in available_types (list)
        _items = []
        if self.available_types:
            for _item_available_types in self.available_types:
                if _item_available_types:
                    _items.append(_item_available_types.to_dict())
            _dict['availableTypes'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AvailableWorkflowTriggers from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "availableTypes": [AvailableWorkflowTriggerTypes.from_dict(_item) for _item in obj["availableTypes"]] if obj.get("availableTypes") is not None else None,
            "ruleKey": obj.get("ruleKey")
        })
        return _obj


