# coding: utf-8

"""
    The Jira Cloud platform REST API

    Jira Cloud platform REST API documentation

    The version of the OpenAPI document: 1001.0.0-SNAPSHOT-7ce0ee67a52d004425175cea962ad1c1c7200181
    Contact: ecosystem@atlassian.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class FieldUpdateOperation(BaseModel):
    """
    Details of an operation to perform on a field.
    """ # noqa: E501
    add: Optional[Any] = Field(default=None, description="The value to add to the field.")
    copy: Optional[Any] = Field(default=None, description="The field value to copy from another issue.")
    edit: Optional[Any] = Field(default=None, description="The value to edit in the field.")
    remove: Optional[Any] = Field(default=None, description="The value to removed from the field.")
    set: Optional[Any] = Field(default=None, description="The value to set in the field.")
    __properties: ClassVar[List[str]] = ["add", "copy", "edit", "remove", "set"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FieldUpdateOperation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if add (nullable) is None
        # and model_fields_set contains the field
        if self.add is None and "add" in self.model_fields_set:
            _dict['add'] = None

        # set to None if copy (nullable) is None
        # and model_fields_set contains the field
        if self.copy is None and "copy" in self.model_fields_set:
            _dict['copy'] = None

        # set to None if edit (nullable) is None
        # and model_fields_set contains the field
        if self.edit is None and "edit" in self.model_fields_set:
            _dict['edit'] = None

        # set to None if remove (nullable) is None
        # and model_fields_set contains the field
        if self.remove is None and "remove" in self.model_fields_set:
            _dict['remove'] = None

        # set to None if set (nullable) is None
        # and model_fields_set contains the field
        if self.set is None and "set" in self.model_fields_set:
            _dict['set'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FieldUpdateOperation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "add": obj.get("add"),
            "copy": obj.get("copy"),
            "edit": obj.get("edit"),
            "remove": obj.get("remove"),
            "set": obj.get("set")
        })
        return _obj


