# coding: utf-8

"""
    The Jira Cloud platform REST API

    Jira Cloud platform REST API documentation

    The version of the OpenAPI document: 1001.0.0-SNAPSHOT-7ce0ee67a52d004425175cea962ad1c1c7200181
    Contact: ecosystem@atlassian.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from jira_client.models.document_version import DocumentVersion
from jira_client.models.project_issue_types import ProjectIssueTypes
from jira_client.models.workflow_layout import WorkflowLayout
from jira_client.models.workflow_reference_status import WorkflowReferenceStatus
from jira_client.models.workflow_scope import WorkflowScope
from jira_client.models.workflow_transitions import WorkflowTransitions
from typing import Optional, Set
from typing_extensions import Self

class JiraWorkflow(BaseModel):
    """
    Details of a workflow.
    """ # noqa: E501
    created: Optional[StrictStr] = Field(default=None, description="The creation date of the workflow.")
    description: Optional[StrictStr] = Field(default=None, description="The description of the workflow.")
    id: Optional[StrictStr] = Field(default=None, description="The ID of the workflow.")
    is_editable: Optional[StrictBool] = Field(default=None, description="Indicates if the workflow can be edited.", alias="isEditable")
    looped_transition_container_layout: Optional[WorkflowLayout] = Field(default=None, alias="loopedTransitionContainerLayout")
    name: Optional[StrictStr] = Field(default=None, description="The name of the workflow.")
    scope: Optional[WorkflowScope] = None
    start_point_layout: Optional[WorkflowLayout] = Field(default=None, alias="startPointLayout")
    statuses: Optional[List[WorkflowReferenceStatus]] = Field(default=None, description="The statuses referenced in this workflow.")
    task_id: Optional[StrictStr] = Field(default=None, description="If there is a current [asynchronous task](#async-operations) operation for this workflow.", alias="taskId")
    transitions: Optional[List[WorkflowTransitions]] = Field(default=None, description="The transitions of the workflow. Note that a transition can have either the deprecated `to`/`from` fields or the `toStatusReference`/`links` fields, but never both nor a combination.")
    updated: Optional[StrictStr] = Field(default=None, description="The last edited date of the workflow.")
    usages: Optional[List[Optional[ProjectIssueTypes]]] = Field(default=None, description="Deprecated. See the [deprecation notice](https://developer.atlassian.com/cloud/jira/platform/changelog/#CHANGE-2298) for details.  Use the optional `workflows.usages` expand to get additional information about the projects and issue types associated with the requested workflows.")
    version: Optional[DocumentVersion] = None
    __properties: ClassVar[List[str]] = ["created", "description", "id", "isEditable", "loopedTransitionContainerLayout", "name", "scope", "startPointLayout", "statuses", "taskId", "transitions", "updated", "usages", "version"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of JiraWorkflow from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of looped_transition_container_layout
        if self.looped_transition_container_layout:
            _dict['loopedTransitionContainerLayout'] = self.looped_transition_container_layout.to_dict()
        # override the default output from pydantic by calling `to_dict()` of scope
        if self.scope:
            _dict['scope'] = self.scope.to_dict()
        # override the default output from pydantic by calling `to_dict()` of start_point_layout
        if self.start_point_layout:
            _dict['startPointLayout'] = self.start_point_layout.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in statuses (list)
        _items = []
        if self.statuses:
            for _item_statuses in self.statuses:
                if _item_statuses:
                    _items.append(_item_statuses.to_dict())
            _dict['statuses'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in transitions (list)
        _items = []
        if self.transitions:
            for _item_transitions in self.transitions:
                if _item_transitions:
                    _items.append(_item_transitions.to_dict())
            _dict['transitions'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in usages (list)
        _items = []
        if self.usages:
            for _item_usages in self.usages:
                if _item_usages:
                    _items.append(_item_usages.to_dict())
            _dict['usages'] = _items
        # override the default output from pydantic by calling `to_dict()` of version
        if self.version:
            _dict['version'] = self.version.to_dict()
        # set to None if created (nullable) is None
        # and model_fields_set contains the field
        if self.created is None and "created" in self.model_fields_set:
            _dict['created'] = None

        # set to None if looped_transition_container_layout (nullable) is None
        # and model_fields_set contains the field
        if self.looped_transition_container_layout is None and "looped_transition_container_layout" in self.model_fields_set:
            _dict['loopedTransitionContainerLayout'] = None

        # set to None if start_point_layout (nullable) is None
        # and model_fields_set contains the field
        if self.start_point_layout is None and "start_point_layout" in self.model_fields_set:
            _dict['startPointLayout'] = None

        # set to None if task_id (nullable) is None
        # and model_fields_set contains the field
        if self.task_id is None and "task_id" in self.model_fields_set:
            _dict['taskId'] = None

        # set to None if updated (nullable) is None
        # and model_fields_set contains the field
        if self.updated is None and "updated" in self.model_fields_set:
            _dict['updated'] = None

        # set to None if usages (nullable) is None
        # and model_fields_set contains the field
        if self.usages is None and "usages" in self.model_fields_set:
            _dict['usages'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of JiraWorkflow from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "created": obj.get("created"),
            "description": obj.get("description"),
            "id": obj.get("id"),
            "isEditable": obj.get("isEditable"),
            "loopedTransitionContainerLayout": WorkflowLayout.from_dict(obj["loopedTransitionContainerLayout"]) if obj.get("loopedTransitionContainerLayout") is not None else None,
            "name": obj.get("name"),
            "scope": WorkflowScope.from_dict(obj["scope"]) if obj.get("scope") is not None else None,
            "startPointLayout": WorkflowLayout.from_dict(obj["startPointLayout"]) if obj.get("startPointLayout") is not None else None,
            "statuses": [WorkflowReferenceStatus.from_dict(_item) for _item in obj["statuses"]] if obj.get("statuses") is not None else None,
            "taskId": obj.get("taskId"),
            "transitions": [WorkflowTransitions.from_dict(_item) for _item in obj["transitions"]] if obj.get("transitions") is not None else None,
            "updated": obj.get("updated"),
            "usages": [ProjectIssueTypes.from_dict(_item) for _item in obj["usages"]] if obj.get("usages") is not None else None,
            "version": DocumentVersion.from_dict(obj["version"]) if obj.get("version") is not None else None
        })
        return _obj


