# coding: utf-8

"""
    The Jira Cloud platform REST API

    Jira Cloud platform REST API documentation

    The version of the OpenAPI document: 1001.0.0-SNAPSHOT-7ce0ee67a52d004425175cea962ad1c1c7200181
    Contact: ecosystem@atlassian.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from jira_client.models.error_collection import ErrorCollection
from jira_client.models.warning_collection import WarningCollection
from typing import Optional, Set
from typing_extensions import Self

class NestedResponse(BaseModel):
    """
    NestedResponse
    """ # noqa: E501
    error_collection: Optional[ErrorCollection] = Field(default=None, alias="errorCollection")
    status: Optional[StrictInt] = None
    warning_collection: Optional[WarningCollection] = Field(default=None, alias="warningCollection")
    __properties: ClassVar[List[str]] = ["errorCollection", "status", "warningCollection"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NestedResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of error_collection
        if self.error_collection:
            _dict['errorCollection'] = self.error_collection.to_dict()
        # override the default output from pydantic by calling `to_dict()` of warning_collection
        if self.warning_collection:
            _dict['warningCollection'] = self.warning_collection.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NestedResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "errorCollection": ErrorCollection.from_dict(obj["errorCollection"]) if obj.get("errorCollection") is not None else None,
            "status": obj.get("status"),
            "warningCollection": WarningCollection.from_dict(obj["warningCollection"]) if obj.get("warningCollection") is not None else None
        })
        return _obj


