# coding: utf-8

"""
    The Jira Cloud platform REST API

    Jira Cloud platform REST API documentation

    The version of the OpenAPI document: 1001.0.0-SNAPSHOT-7ce0ee67a52d004425175cea962ad1c1c7200181
    Contact: ecosystem@atlassian.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from jira_client.models.workflow_scheme import WorkflowScheme
from typing import Optional, Set
from typing_extensions import Self

class PageBeanWorkflowScheme(BaseModel):
    """
    A page of items.
    """ # noqa: E501
    is_last: Optional[StrictBool] = Field(default=None, description="Whether this is the last page.", alias="isLast")
    max_results: Optional[StrictInt] = Field(default=None, description="The maximum number of items that could be returned.", alias="maxResults")
    next_page: Optional[StrictStr] = Field(default=None, description="If there is another page of results, the URL of the next page.", alias="nextPage")
    var_self: Optional[StrictStr] = Field(default=None, description="The URL of the page.", alias="self")
    start_at: Optional[StrictInt] = Field(default=None, description="The index of the first item returned.", alias="startAt")
    total: Optional[StrictInt] = Field(default=None, description="The number of items returned.")
    values: Optional[List[WorkflowScheme]] = Field(default=None, description="The list of items.")
    __properties: ClassVar[List[str]] = ["isLast", "maxResults", "nextPage", "self", "startAt", "total", "values"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PageBeanWorkflowScheme from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "is_last",
            "max_results",
            "next_page",
            "var_self",
            "start_at",
            "total",
            "values",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in values (list)
        _items = []
        if self.values:
            for _item_values in self.values:
                if _item_values:
                    _items.append(_item_values.to_dict())
            _dict['values'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PageBeanWorkflowScheme from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "isLast": obj.get("isLast"),
            "maxResults": obj.get("maxResults"),
            "nextPage": obj.get("nextPage"),
            "self": obj.get("self"),
            "startAt": obj.get("startAt"),
            "total": obj.get("total"),
            "values": [WorkflowScheme.from_dict(_item) for _item in obj["values"]] if obj.get("values") is not None else None
        })
        return _obj


