# coding: utf-8

"""
    The Jira Cloud platform REST API

    Jira Cloud platform REST API documentation

    The version of the OpenAPI document: 1001.0.0-SNAPSHOT-7ce0ee67a52d004425175cea962ad1c1c7200181
    Contact: ecosystem@atlassian.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from jira_client.models.expand_priority_scheme_page import ExpandPrioritySchemePage
from typing import Optional, Set
from typing_extensions import Self

class Priority(BaseModel):
    """
    An issue priority.
    """ # noqa: E501
    avatar_id: Optional[StrictInt] = Field(default=None, description="The avatarId of the avatar for the issue priority. This parameter is nullable and when set, this avatar references the universal avatar APIs.", alias="avatarId")
    description: Optional[StrictStr] = Field(default=None, description="The description of the issue priority.")
    icon_url: Optional[StrictStr] = Field(default=None, description="The URL of the icon for the issue priority.", alias="iconUrl")
    id: Optional[StrictStr] = Field(default=None, description="The ID of the issue priority.")
    is_default: Optional[StrictBool] = Field(default=None, description="Whether this priority is the default.", alias="isDefault")
    name: Optional[StrictStr] = Field(default=None, description="The name of the issue priority.")
    schemes: Optional[ExpandPrioritySchemePage] = Field(default=None, description="Priority schemes associated with the issue priority.")
    var_self: Optional[StrictStr] = Field(default=None, description="The URL of the issue priority.", alias="self")
    status_color: Optional[StrictStr] = Field(default=None, description="The color used to indicate the issue priority.", alias="statusColor")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["avatarId", "description", "iconUrl", "id", "isDefault", "name", "schemes", "self", "statusColor"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Priority from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of schemes
        if self.schemes:
            _dict['schemes'] = self.schemes.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Priority from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "avatarId": obj.get("avatarId"),
            "description": obj.get("description"),
            "iconUrl": obj.get("iconUrl"),
            "id": obj.get("id"),
            "isDefault": obj.get("isDefault"),
            "name": obj.get("name"),
            "schemes": ExpandPrioritySchemePage.from_dict(obj["schemes"]) if obj.get("schemes") is not None else None,
            "self": obj.get("self"),
            "statusColor": obj.get("statusColor")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


