# coding: utf-8

"""
    The Jira Cloud platform REST API

    Jira Cloud platform REST API documentation

    The version of the OpenAPI document: 1001.0.0-SNAPSHOT-7ce0ee67a52d004425175cea962ad1c1c7200181
    Contact: ecosystem@atlassian.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class TimeTrackingDetails(BaseModel):
    """
    Time tracking details.
    """ # noqa: E501
    original_estimate: Optional[StrictStr] = Field(default=None, description="The original estimate of time needed for this issue in readable format.", alias="originalEstimate")
    original_estimate_seconds: Optional[StrictInt] = Field(default=None, description="The original estimate of time needed for this issue in seconds.", alias="originalEstimateSeconds")
    remaining_estimate: Optional[StrictStr] = Field(default=None, description="The remaining estimate of time needed for this issue in readable format.", alias="remainingEstimate")
    remaining_estimate_seconds: Optional[StrictInt] = Field(default=None, description="The remaining estimate of time needed for this issue in seconds.", alias="remainingEstimateSeconds")
    time_spent: Optional[StrictStr] = Field(default=None, description="Time worked on this issue in readable format.", alias="timeSpent")
    time_spent_seconds: Optional[StrictInt] = Field(default=None, description="Time worked on this issue in seconds.", alias="timeSpentSeconds")
    __properties: ClassVar[List[str]] = ["originalEstimate", "originalEstimateSeconds", "remainingEstimate", "remainingEstimateSeconds", "timeSpent", "timeSpentSeconds"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TimeTrackingDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "original_estimate",
            "original_estimate_seconds",
            "remaining_estimate",
            "remaining_estimate_seconds",
            "time_spent",
            "time_spent_seconds",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TimeTrackingDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "originalEstimate": obj.get("originalEstimate"),
            "originalEstimateSeconds": obj.get("originalEstimateSeconds"),
            "remainingEstimate": obj.get("remainingEstimate"),
            "remainingEstimateSeconds": obj.get("remainingEstimateSeconds"),
            "timeSpent": obj.get("timeSpent"),
            "timeSpentSeconds": obj.get("timeSpentSeconds")
        })
        return _obj


