# coding: utf-8

"""
    The Jira Cloud platform REST API

    Jira Cloud platform REST API documentation

    The version of the OpenAPI document: 1001.0.0-SNAPSHOT-7ce0ee67a52d004425175cea962ad1c1c7200181
    Contact: ecosystem@atlassian.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from jira_client.models.transition_screen_details import TransitionScreenDetails
from jira_client.models.workflow_rules import WorkflowRules
from typing import Optional, Set
from typing_extensions import Self

class Transition(BaseModel):
    """
    Details of a workflow transition.
    """ # noqa: E501
    description: StrictStr = Field(description="The description of the transition.")
    var_from: List[StrictStr] = Field(description="The statuses the transition can start from.", alias="from")
    id: StrictStr = Field(description="The ID of the transition.")
    name: StrictStr = Field(description="The name of the transition.")
    properties: Optional[Dict[str, Any]] = Field(default=None, description="The properties of the transition.")
    rules: Optional[WorkflowRules] = None
    screen: Optional[TransitionScreenDetails] = None
    to: StrictStr = Field(description="The status the transition goes to.")
    type: StrictStr = Field(description="The type of the transition.")
    __properties: ClassVar[List[str]] = ["description", "from", "id", "name", "properties", "rules", "screen", "to", "type"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['global', 'initial', 'directed']):
            raise ValueError("must be one of enum values ('global', 'initial', 'directed')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Transition from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of rules
        if self.rules:
            _dict['rules'] = self.rules.to_dict()
        # override the default output from pydantic by calling `to_dict()` of screen
        if self.screen:
            _dict['screen'] = self.screen.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Transition from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "description": obj.get("description"),
            "from": obj.get("from"),
            "id": obj.get("id"),
            "name": obj.get("name"),
            "properties": obj.get("properties"),
            "rules": WorkflowRules.from_dict(obj["rules"]) if obj.get("rules") is not None else None,
            "screen": TransitionScreenDetails.from_dict(obj["screen"]) if obj.get("screen") is not None else None,
            "to": obj.get("to"),
            "type": obj.get("type")
        })
        return _obj


