# coding: utf-8

"""
    The Jira Cloud platform REST API

    Jira Cloud platform REST API documentation

    The version of the OpenAPI document: 1001.0.0-SNAPSHOT-7ce0ee67a52d004425175cea962ad1c1c7200181
    Contact: ecosystem@atlassian.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class UserBeanAvatarUrls(BaseModel):
    """
    UserBeanAvatarUrls
    """ # noqa: E501
    var_16x16: Optional[StrictStr] = Field(default=None, description="The URL of the user's 16x16 pixel avatar.", alias="16x16")
    var_24x24: Optional[StrictStr] = Field(default=None, description="The URL of the user's 24x24 pixel avatar.", alias="24x24")
    var_32x32: Optional[StrictStr] = Field(default=None, description="The URL of the user's 32x32 pixel avatar.", alias="32x32")
    var_48x48: Optional[StrictStr] = Field(default=None, description="The URL of the user's 48x48 pixel avatar.", alias="48x48")
    __properties: ClassVar[List[str]] = ["16x16", "24x24", "32x32", "48x48"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UserBeanAvatarUrls from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UserBeanAvatarUrls from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "16x16": obj.get("16x16"),
            "24x24": obj.get("24x24"),
            "32x32": obj.get("32x32"),
            "48x48": obj.get("48x48")
        })
        return _obj


