# coding: utf-8

"""
    The Jira Cloud platform REST API

    Jira Cloud platform REST API documentation

    The version of the OpenAPI document: 1001.0.0-SNAPSHOT-7ce0ee67a52d004425175cea962ad1c1c7200181
    Contact: ecosystem@atlassian.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from jira_client.models.status_layout_update import StatusLayoutUpdate
from jira_client.models.transition_update_dto import TransitionUpdateDTO
from jira_client.models.workflow_layout import WorkflowLayout
from typing import Optional, Set
from typing_extensions import Self

class WorkflowCreate(BaseModel):
    """
    The details of the workflows to create.
    """ # noqa: E501
    description: Optional[StrictStr] = Field(default=None, description="The description of the workflow to create.")
    looped_transition_container_layout: Optional[WorkflowLayout] = Field(default=None, alias="loopedTransitionContainerLayout")
    name: StrictStr = Field(description="The name of the workflow to create.")
    start_point_layout: Optional[WorkflowLayout] = Field(default=None, alias="startPointLayout")
    statuses: List[StatusLayoutUpdate] = Field(description="The statuses associated with this workflow.")
    transitions: List[TransitionUpdateDTO] = Field(description="The transitions of this workflow.")
    __properties: ClassVar[List[str]] = ["description", "loopedTransitionContainerLayout", "name", "startPointLayout", "statuses", "transitions"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WorkflowCreate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of looped_transition_container_layout
        if self.looped_transition_container_layout:
            _dict['loopedTransitionContainerLayout'] = self.looped_transition_container_layout.to_dict()
        # override the default output from pydantic by calling `to_dict()` of start_point_layout
        if self.start_point_layout:
            _dict['startPointLayout'] = self.start_point_layout.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in statuses (list)
        _items = []
        if self.statuses:
            for _item_statuses in self.statuses:
                if _item_statuses:
                    _items.append(_item_statuses.to_dict())
            _dict['statuses'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in transitions (list)
        _items = []
        if self.transitions:
            for _item_transitions in self.transitions:
                if _item_transitions:
                    _items.append(_item_transitions.to_dict())
            _dict['transitions'] = _items
        # set to None if looped_transition_container_layout (nullable) is None
        # and model_fields_set contains the field
        if self.looped_transition_container_layout is None and "looped_transition_container_layout" in self.model_fields_set:
            _dict['loopedTransitionContainerLayout'] = None

        # set to None if start_point_layout (nullable) is None
        # and model_fields_set contains the field
        if self.start_point_layout is None and "start_point_layout" in self.model_fields_set:
            _dict['startPointLayout'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WorkflowCreate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "description": obj.get("description"),
            "loopedTransitionContainerLayout": WorkflowLayout.from_dict(obj["loopedTransitionContainerLayout"]) if obj.get("loopedTransitionContainerLayout") is not None else None,
            "name": obj.get("name"),
            "startPointLayout": WorkflowLayout.from_dict(obj["startPointLayout"]) if obj.get("startPointLayout") is not None else None,
            "statuses": [StatusLayoutUpdate.from_dict(_item) for _item in obj["statuses"]] if obj.get("statuses") is not None else None,
            "transitions": [TransitionUpdateDTO.from_dict(_item) for _item in obj["transitions"]] if obj.get("transitions") is not None else None
        })
        return _obj


