# coding: utf-8

"""
    The Jira Cloud platform REST API

    Jira Cloud platform REST API documentation

    The version of the OpenAPI document: 1001.0.0-SNAPSHOT-7ce0ee67a52d004425175cea962ad1c1c7200181
    Contact: ecosystem@atlassian.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from jira_client.models.project_create_resource_identifier import ProjectCreateResourceIdentifier
from typing import Optional, Set
from typing_extensions import Self

class BoardColumnPayload(BaseModel):
    """
    The payload for creating a board column
    """ # noqa: E501
    maximum_issue_constraint: Optional[StrictInt] = Field(default=None, description="The maximum issue constraint for the column", alias="maximumIssueConstraint")
    minimum_issue_constraint: Optional[StrictInt] = Field(default=None, description="The minimum issue constraint for the column", alias="minimumIssueConstraint")
    name: Optional[StrictStr] = Field(default=None, description="The name of the column")
    status_ids: Optional[List[ProjectCreateResourceIdentifier]] = Field(default=None, description="The status IDs for the column", alias="statusIds")
    __properties: ClassVar[List[str]] = ["maximumIssueConstraint", "minimumIssueConstraint", "name", "statusIds"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BoardColumnPayload from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in status_ids (list)
        _items = []
        if self.status_ids:
            for _item_status_ids in self.status_ids:
                if _item_status_ids:
                    _items.append(_item_status_ids.to_dict())
            _dict['statusIds'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BoardColumnPayload from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "maximumIssueConstraint": obj.get("maximumIssueConstraint"),
            "minimumIssueConstraint": obj.get("minimumIssueConstraint"),
            "name": obj.get("name"),
            "statusIds": [ProjectCreateResourceIdentifier.from_dict(_item) for _item in obj["statusIds"]] if obj.get("statusIds") is not None else None
        })
        return _obj


