# coding: utf-8

"""
    The Jira Cloud platform REST API

    Jira Cloud platform REST API documentation

    The version of the OpenAPI document: 1001.0.0-SNAPSHOT-7ce0ee67a52d004425175cea962ad1c1c7200181
    Contact: ecosystem@atlassian.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from jira_client.models.project_create_resource_identifier import ProjectCreateResourceIdentifier
from jira_client.models.role_payload import RolePayload
from typing import Optional, Set
from typing_extensions import Self

class RolesCapabilityPayload(BaseModel):
    """
    RolesCapabilityPayload
    """ # noqa: E501
    role_to_project_actors: Optional[Dict[str, List[ProjectCreateResourceIdentifier]]] = Field(default=None, description="A map of role PCRI (can be ID or REF) to a list of user or group PCRI IDs to associate with the role and project.", alias="roleToProjectActors")
    roles: Optional[List[RolePayload]] = Field(default=None, description="The list of roles to create.")
    __properties: ClassVar[List[str]] = ["roleToProjectActors", "roles"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RolesCapabilityPayload from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in role_to_project_actors (dict of array)
        _field_dict_of_array = {}
        if self.role_to_project_actors:
            for _key_role_to_project_actors in self.role_to_project_actors:
                if self.role_to_project_actors[_key_role_to_project_actors] is not None:
                    _field_dict_of_array[_key_role_to_project_actors] = [
                        _item.to_dict() for _item in self.role_to_project_actors[_key_role_to_project_actors]
                    ]
            _dict['roleToProjectActors'] = _field_dict_of_array
        # override the default output from pydantic by calling `to_dict()` of each item in roles (list)
        _items = []
        if self.roles:
            for _item_roles in self.roles:
                if _item_roles:
                    _items.append(_item_roles.to_dict())
            _dict['roles'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RolesCapabilityPayload from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "roleToProjectActors": dict(
                (_k,
                        [ProjectCreateResourceIdentifier.from_dict(_item) for _item in _v]
                        if _v is not None
                        else None
                )
                for _k, _v in obj.get("roleToProjectActors", {}).items()
            ),
            "roles": [RolePayload.from_dict(_item) for _item in obj["roles"]] if obj.get("roles") is not None else None
        })
        return _obj


